Bug Hunting Session
Bug 103365 - Text isn't showing in the new commonsallayout if OpenGL is on
Summary: Text isn't showing in the new commonsallayout if OpenGL is on
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: graphics stack (show other bugs)
Version:
(earliest affected)
5.3.0.0.alpha0+
Hardware: All Windows (All)
: medium major
Assignee: Not Assigned
URL:
Whiteboard: target:5.3.0
Keywords:
Depends on:
Blocks: HarfBuzz
  Show dependency treegraph
 
Reported: 2016-10-20 20:07 UTC by Aron Budea
Modified: 2016-10-22 05:51 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:


Attachments
Screenshot with OpenGL enabled (69.14 KB, image/png)
2016-10-20 20:07 UTC, Aron Budea
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Aron Budea 2016-10-20 20:07:27 UTC
Created attachment 128105 [details]
Screenshot with OpenGL enabled

Using the laster master build on Windows 7, OpenGL is enabled.

I typed this:
SET SAL_USE_COMMON_LAYOUT=1
soffice.exe --writer

LibreOffice looks like the attached image (there's already text typed in the document that isn't showing, either).
Note that when I'm navigating through the menus, the menu texts briefly flash up, and disappear again.
Also, looks fine if OpenGL is turned off.

Version: 5.3.0.0.alpha0+
Build ID: c2b48a763df113e63e6a27ee05b9a6834e4e49a4
CPU Threads: 4; OS Version: Windows 6.1; UI Render: default; 
TinderBox: Win-x86@62-merge-TDF, Branch:MASTER, Time: 2016-10-20_06:56:44
Locale: hu-HU (hu_HU); Calc: CL
Comment 1 Aron Budea 2016-10-20 20:39:23 UTC
As advised by Khaled, tried with adding this as well:
SET SAL_DWRITE_COMMON_LAYOUT=1

Result is the same.
Comment 2 V Stuart Foote 2016-10-20 20:50:47 UTC
@Aron, you beat me to it :-)

On Windows 8.1 Ent 64-bit en-US with

Version: 5.3.0.0.alpha0+
Build ID: c2b48a763df113e63e6a27ee05b9a6834e4e49a4
CPU Threads: 8; OS Version: Windows 6.2; UI Render: GL; 
TinderBox: Win-x86@62-merge-TDF, Branch:MASTER, Time: 2016-10-20_06:56:44
Locale: en-US (en_US); Calc: CL

With a SAL_USE_COMMON_LAYOUT present *AND* OpenGL rendering enabled the text is not rendered visible to the UI.  It is present (I copied pasted the above).

With SAL_USE_COMMON_LAYOUT present *AND* default rendering (OpenGL unchecked) the text is rendered visible to the UI--and no longer is fall-back to Segoe UI system font! Yay!

Removing env variable, i.e. entering "set SAL_USE_COMMON_LAYOUT=" and restarting LO restores both OpenGL rendering and default rendering of canvas (including use of Segoe UI with default).
Comment 3 V Stuart Foote 2016-10-21 13:33:10 UTC
And yes, it manifests in the Alpha1 build with SAL_USE_COMMON_LAYOUT set *AND* OpenGL rendering. Likely the default for anyone testing.

On Windows 10 Pro 64-bit (1607) en-US

Version: 5.3.0.0.alpha1 (x64)
Build ID: f4ca1573fcf445164c068c1046ab5d084e1b005f
CPU Threads: 8; OS Version: Windows 6.19; UI Render: GL; 
Locale: en-US (en_US); Calc: CL
Comment 4 V Stuart Foote 2016-10-21 15:27:11 UTC
Khaled has a patch up for review

https://gerrit.libreoffice.org/#/c/30123/
Comment 5 Commit Notification 2016-10-21 18:50:38 UTC
Khaled Hosny committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=36bafd3d4ad7fa75649eeab0c9cd1b3d6f53d8e8

tdf#103365: Try to fix Windows OpenGL rendering

It will be available in 5.3.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 6 Khaled Hosny 2016-10-21 18:52:49 UTC
Text should be visible now. There seem to be some antialising issues that we are checking.
Comment 7 V Stuart Foote 2016-10-22 05:51:49 UTC
On Windows 10 Pro 64-bit (1607) en-US with
Version: 5.3.0.0.alpha1+
Build ID: 36bafd3d4ad7fa75649eeab0c9cd1b3d6f53d8e8
CPU Threads: 8; OS Version: Windows 6.19; UI Render: GL; 
TinderBox: Win-x86@39, Branch:master, Time: 2016-10-21_18:49:50
Locale: en-US (en_US); Calc: CL

Enable Harfbuzz common layout and launch LibreOffice with

cd to $ORIGIN\program folder

set SAL_USE_COMMON_LAYOUT=1

.\soffice.exe

All text now fully rendered with OpenGL or default GPU, or just CPU based rendering.

Some jaggies & lack of AntiAlaising, but fonts render well otherwise. Fall back issues seem more sane.